#!/usr/bin/env python
###########################################################
#               WARNING: Generated code!                  #
#              **************************                 #
# Manual changes may get lost if file is generated again. #
# Only code inside the [MANUAL] tags will be kept.        #
###########################################################

import roslib; roslib.load_manifest('behavior_concurrent_test')
from flexbe_core import Behavior, Autonomy, OperatableStateMachine, ConcurrencyContainer, PriorityContainer, Logger
from flexbe_states.operator_decision_state import OperatorDecisionState
from flexbe_states.log_state import LogState
from concurrent_test_flexbe_states.verbose_logger import VerboseLoggerState
# Additional imports can be added inside the following tags
# [MANUAL_IMPORT]

# [/MANUAL_IMPORT]


'''
Created on Fri Aug 12 2016
@author: Justin Willis
'''
class ConcurrentTestSM(Behavior):
	'''
	Tests the functionality of a concurrent state
	'''


	def __init__(self):
		super(ConcurrentTestSM, self).__init__()
		self.name = 'Concurrent Test'

		# parameters of this behavior

		# references to used behaviors

		# Additional initialization code can be added inside the following tags
		# [MANUAL_INIT]
		
		# [/MANUAL_INIT]

		# Behavior comments:



	def create(self):
		# x:83 y:140
		_state_machine = OperatableStateMachine(outcomes=['finished'])

		# Additional creation code can be added inside the following tags
		# [MANUAL_CREATE]
		
		# [/MANUAL_CREATE]

		# x:383 y:90, x:383 y:190, x:383 y:290, x:383 y:390
		_sm_container_0 = ConcurrencyContainer(outcomes=['finished'], conditions=[
										('finished', [('A', 'done')]),
										('finished', [('B', 'done')]),
										('finished', [('C', 'done')])
										])

		with _sm_container_0:
			# x:142 y:78
			OperatableStateMachine.add('A',
										VerboseLoggerState(),
										transitions={'done': 'finished'},
										autonomy={'done': Autonomy.Off})

			# x:142 y:170
			OperatableStateMachine.add('B',
										VerboseLoggerState(),
										transitions={'done': 'finished'},
										autonomy={'done': Autonomy.Off})

			# x:142 y:270
			OperatableStateMachine.add('C',
										VerboseLoggerState(),
										transitions={'done': 'finished'},
										autonomy={'done': Autonomy.Off})



		with _state_machine:
			# x:187 y:70
			OperatableStateMachine.add('Ready',
										OperatorDecisionState(outcomes=['yes', 'no'], hint=None, suggestion=None),
										transitions={'yes': 'Log Start', 'no': 'finished'},
										autonomy={'yes': Autonomy.Off, 'no': Autonomy.Off})

			# x:216 y:220
			OperatableStateMachine.add('Log Start',
										LogState(text='Entering concurrent state', severity=Logger.REPORT_HINT),
										transitions={'done': 'Container'},
										autonomy={'done': Autonomy.Off})

			# x:397 y:217
			OperatableStateMachine.add('Container',
										_sm_container_0,
										transitions={'finished': 'Log Stop'},
										autonomy={'finished': Autonomy.Inherit})

			# x:416 y:70
			OperatableStateMachine.add('Log Stop',
										LogState(text='Exiting concurrent state', severity=Logger.REPORT_HINT),
										transitions={'done': 'Ready'},
										autonomy={'done': Autonomy.Off})


		return _state_machine


	# Private functions can be added inside the following tags
	# [MANUAL_FUNC]
	
	# [/MANUAL_FUNC]
