#!/usr/bin/env python

import rospy
import time

from flexbe_core import EventState, Logger

class VerboseLoggerState(EventState):
	'''
	Verbosely loggs all state mechanics

	<= done  Given time has passed.

	'''

	def __init__(self):
		super(VerboseLoggerState, self).__init__(outcomes = ['done'])

	def execute(self, userdata):
		Logger.loginfo('[%s] Execute' % self.name)
		time.sleep(1)

	def on_enter(self, userdata):
		Logger.logerr('[%s] On enter' % self.name)

	def on_exit(self, userdata):
		Logger.logerr('[%s] On exit' % self.name)

	def on_start(self):
		Logger.logwarn('[%s] On start' % self.name)

	def on_stop(self):
		Logger.logwarn('[%s] On stop' % self.name)
